unit Main;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, ComCtrls, ExtCtrls, Buttons, Gauges, Menus;

type
  TMainForm = class(TForm)
    PageControl1: TPageControl;
    TabSheet1: TTabSheet;
    TabSheet2: TTabSheet;
    Memo1: TMemo;
    Memo2: TMemo;
    Panel1: TPanel;
    BitBtn1: TBitBtn;
    Gauge1: TGauge;
    MainMenu1: TMainMenu;
    MenuFile: TMenuItem;
    MenuExit: TMenuItem;
    MenuMisc: TMenuItem;
    MenuInfo: TMenuItem;
    MenuStayOnTop: TMenuItem;
    procedure FormCreate(Sender: TObject);
    procedure BitBtn1Click(Sender: TObject);
    procedure MenuInfoClick(Sender: TObject);
    procedure MenuExitClick(Sender: TObject);
    procedure MenuStayOnTopClick(Sender: TObject);
  private
    { Private 錾 }
  public
    { Public 錾 }
  end;

var
  MainForm: TMainForm;

implementation

{$R *.dfm}

uses
    fjutil, Jconvert, Info;

//  ---------------------------------------------------------------------------
//  RXgN^
procedure TMainForm.FormCreate(Sender: TObject);
begin
    FBox.SetCaption(Self);
end;

//  ---------------------------------------------------------------------------
//  w肵URL̃\[X擾
function    GetPage(const URL: string; Page: TStrings): Boolean;
var
    S: TMemoryStream;
begin
    Result := false;
    S :=TMemoryStream.Create;
    S.Position := 0;
    try
        try
            INet.GetHtmlFile(S, URL);
            S.Position := 0;
            Page.LoadFromStream(S);

            //  R[hϊ
            Page.Text := ConvertJCode(Page.Text, SJIS_OUT);

            Result := true;
        finally
            S.Free;
        end;
    except
        ;
    end;
end;

//  ---------------------------------------------------------------------------
//  HTML̃^Cg擾
function    GetTitle(Page: TStrings): string;
var
    i, Temp: integer;
    Line: string;
    Found: Boolean;
begin
    Result := '';

    //  </title>̂s
    //  2sɕďĂꍇ͒m
    Line := '';
    Found := false;
    for i := 0 to Page.Count - 1 do
    begin
        Line := Page[i];
        Found := AnsiPos('</title>', LowerCase(Line)) > 0;
        if (Found) then break;
    end;
    //  ꍇA̍s^Cgo
    if (Found) then
    begin
        //  </title> ȍ~̕폜
        Temp := AnsiPos('</title>', LowerCase(Line));
        Line := Copy(Line, 1, Temp - 1);
        //  ɂɊ܂܂Ō>(<title...>̃Pc)ȑO폜
        Temp := LastDelimiter('>', Line);
        //  炻ȍ~^Cg
        //  Ȃ΂ꂪ^Cg
        if (Temp > 0) then Line := Copy(Line, Temp + 1, Length(Line));
        Result := Line;
    end;
end;

//  ---------------------------------------------------------------------------
//  HREF쐬
function    BuildHref(const URL, Title: string): string;
const
    FMT = '<a target="link" href="%s">%s</a>';
var
    T: string;
begin
    //  ^CgȂ΁AURLőp
    if (Title = '') then T := URL else T := Title;
    //  
    Result := Format(FMT, [URL, T]); 
end;

//  ---------------------------------------------------------------------------
//  ܂t
function    DecorateTag(const S: string): string;
var
    S1: string;
begin
    S1 := FormatDateTime(':[yyyy/mm/dd]', Now);
    Result := Format('%s%s%s', ['<li>', S, S1]);
end;    

//  ---------------------------------------------------------------------------
//  s
procedure TMainForm.BitBtn1Click(Sender: TObject);
var
    i: integer;
    URL, Title, Tag: string;
    Page: TStrings;
begin
    Memo2.Clear;
    Page := TStringList.Create;

    Gauge1.MaxValue := Memo1.Lines.Count;
    Gauge1.Progress := 0;

    for i := 0 to Memo1.Lines.Count - 1 do
    begin
        //  URLo
        URL := Memo1.Lines[i];
        //  N璆~
        if not GetPage(URL, Page) then break;
        //  ^Cgo
        Title := GetTitle(Page);
        //  N^O쐬
        Tag := BuildHref(URL, Title);
        //  ǉ
        Memo2.Lines.Add(DecorateTag(Tag));

        Gauge1.AddProgress(1);
    end;
    Gauge1.Progress := 0;

    //  y[W؂ւ
    PageControl1.ActivePageIndex := 1;

    Page.Free;
end;

procedure TMainForm.MenuInfoClick(Sender: TObject);
begin
    OpenInfoForm();
end;

procedure TMainForm.MenuExitClick(Sender: TObject);
begin
    Self.Close();
end;

procedure TMainForm.MenuStayOnTopClick(Sender: TObject);
begin
    if (MenuStayOnTop.Checked) then
        Self.FormStyle := fsStayOnTop
    else
        Self.FormStyle := fsNormal;
end;

end.

